diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/configure.ac cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/configure.ac
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/configure.ac	2005-12-31 21:57:37.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/configure.ac	2006-08-18 00:24:08.371320000 +0900
@@ -97,12 +97,14 @@
     else
 	nls_msg="Built using native support"
     fi
-    LIBS="$LIBS $LIBINTL"
+# fake for shared linking with libiconv and libintl
+#    LIBS="$LIBS $LIBINTL"
+    LIBS="$LIBS $LTLIBINTL"
 else
     nls_msg="Not built"
 fi
 
-nls_msg="Not built"
+#nls_msg="Not built"
 
 NEON_WARNINGS
 
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/po/LINGUAS cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/po/LINGUAS
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/po/LINGUAS	2005-12-31 20:35:51.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/po/LINGUAS	2006-08-06 14:46:57.979537600 +0900
@@ -1,3 +1,4 @@
 es
 it
+ja
 en@quot
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/cadaver.c cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/cadaver.c
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/cadaver.c	2005-12-31 21:57:37.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/cadaver.c	2006-08-01 01:17:56.255238400 +0900
@@ -42,6 +42,13 @@
 #ifdef HAVE_LOCALE_H
 #include <locale.h>
 #endif
+#ifdef HAVE_LANGINFO_CODESET
+#include <langinfo.h>
+#endif
+#if defined(HAVE_ICONV) && defined(__CYGWIN__)
+#define WIN32_LEAN_AND_MEAN
+#include <windows.h>
+#endif
 
 
 #include <errno.h>
@@ -76,6 +83,8 @@
 #include "options.h"
 #include "utils.h"
 
+#include "codeconv.h"
+
 #define DEFAULT_NAMESPACE "http://webdav.org/cadaver/custom-properties/"
 
 #ifdef ENABLE_NETRC
@@ -160,19 +169,26 @@
  * collection. */
 int set_path(const char *newpath)
 {
+    char *pt1, *pt2;
     int is_coll = (getrestype(newpath) == resr_collection);
+
+    pt1 = fromUTF8(pt2 = ne_path_unescape(newpath));
+    free(pt2);
+
     if (is_coll || tolerant) {
 	if (!is_coll) {
 	    session.isdav = 0;
-	    printf(_("Ignored error: %s not WebDAV-enabled:\n%s\n"), newpath,
+	    printf(_("Ignored error: %s not WebDAV-enabled:\n%s\n"), pt1,
 		   ne_get_error(session.sess));
 	} else {
 	    session.isdav = 1;
 	}
+	free(pt1);
 	return 0;
     } else {
-	printf(_("Could not access %s (not WebDAV-enabled?):\n%s\n"), newpath,
+	printf(_("Could not access %s (not WebDAV-enabled?):\n%s\n"), pt1,
 	       ne_get_error(session.sess));
+	free(pt1);
 	return 1;
     }
 }
@@ -220,7 +236,7 @@
     const char *ccfn = userdata;
     int n;
 
-    printf("The server has requested a client certificate.\n");
+    printf(_("The server has requested a client certificate.\n"));
 
 #if 0
     /* display CA names? */
@@ -237,13 +253,13 @@
         
         if (!name) name = ccfn;
         
-        printf("Client certificate `%s' is encrypted.\n", name);
+        printf(_("Client certificate `%s' is encrypted.\n"), name);
         
         for (n = 0; n < 3; n++) {
             pass = fm_getpassword(_("Decryption password: "));
             if (pass == NULL) break;
             if (ne_ssl_clicert_decrypt(client_cert, pass)) {
-                printf("Password incorrect, try again.\n");
+                printf(_("Password incorrect, try again.\n"));
             } else {
                 break;
             }
@@ -251,7 +267,7 @@
     }
     
     if (!ne_ssl_clicert_encrypted(client_cert)) {
-        printf("Using client certificate.\n");
+        printf(_("Using client certificate.\n"));
         ne_ssl_set_clicert(session.sess, client_cert);
     }
     
@@ -270,7 +286,7 @@
         if (client_cert) {
             ne_ssl_provide_clicert(session.sess, provide_clicert, ccfn);
         } else {
-            printf("Could not load client certificate from `%s'.\n",
+            printf(_("Could not load client certificate from `%s'.\n"),
                    ccfn);
         }
     }
@@ -471,10 +487,12 @@
     static char prompt[BUFSIZ];
 
     if (session.uri.path) {
-        char *p = ne_path_unescape(session.uri.path);
+	char *pt;
+        char *p = fromUTF8(pt = ne_path_unescape(session.uri.path));
 	ne_snprintf(prompt, BUFSIZ, "dav:%s%c ", p,
                     session.isdav ? '>' : '?');
         ne_free(p);
+        ne_free(pt);
     } else {
 	sprintf(prompt, "dav:!> ");
     }
@@ -631,7 +649,7 @@
     static time_t last_fetch;
     static char *last_path;
 
-    char *name;
+    char *name, *pt;
     
     if (state == 0) {
 	/* Check to see if we should refresh the dumb cache.
@@ -685,7 +703,8 @@
 	} else {
 	    name = current->uri;
 	}
-	name = ne_path_unescape(name);
+	name = fromUTF8(pt = ne_path_unescape(name));
+	free(pt);
 
 	if (strncmp(text, name, len) == 0) {
 	    current = current->next;
@@ -794,6 +813,22 @@
 }
 #endif
 
+#if defined(HAVE_ICONV) && defined(__CYGWIN__)
+/* Extract from APR implementation misc/win32/charset.c */
+static char* get_cp(void)
+{
+    static char cp[8]; // "CP" + "65535" + NUL
+    LCID locale = GetThreadLocale();
+    if(GetLocaleInfo(locale, LOCALE_IDEFAULTANSICODEPAGE, cp + 2, sizeof(cp) - 2) > 0) {
+	cp[0] = 'C';
+	cp[1] = 'P';
+	return cp;
+    }
+    sprintf(cp, "CP%u", (unsigned short)GetACP());
+    return cp;
+}
+#endif
+
 static void init_options(void)
 {
     char *lockowner, *tmp;
@@ -816,15 +851,20 @@
     lockscope = ne_lockscope_exclusive;
     searchdepth = NE_DEPTH_INFINITE;
 
-    /* This is what Markus Kahn says we should do. */
-    if ((tmp = getenv("LC_ALL")) ||
-	(tmp = getenv("LC_CTYPE")) ||
-	(tmp = getenv("LANG"))) {
-	if (strstr(tmp, "UTF-8")) {
-	    int val = 1;
-	    set_option(opt_utf8, &val);
-	}
-    }
+#ifdef HAVE_ICONV
+#ifdef __CYGWIN__
+    tmp = get_cp();
+    setenv("OUTPUT_CHARSET", tmp, 0); /* Currently, cygwin has no locale support */
+#else
+#ifdef HAVE_LANGINFO_CODESET
+    tmp = nl_langinfo(CODESET);
+#else
+    tmp = _("LOCALCHARSET");
+#endif
+#endif
+    if (strcmp(tmp, "LOCALCHARSET") != 0)
+	set_option(opt_localcharset, ne_strdup(tmp));
+#endif
 
 }
 
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/cmdline.c cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/cmdline.c
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/cmdline.c	2005-12-29 20:44:41.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/cmdline.c	2006-08-01 01:42:37.315580800 +0900
@@ -45,6 +45,7 @@
 #include "cadaver.h"
 #include "cmdline.h"
 #include "utils.h"
+#include "codeconv.h"
 
 static int has_glob_pattern(const char *str) {
     const char *pnt;
@@ -182,7 +183,8 @@
 {
     struct dg_ctx *ctx = NULL;
     struct resource *files;
-    char *real_path = resolve_path(session.uri.path, dir, 1);
+    char *pt;
+    char *real_path = resolve_path(session.uri.path, pt = toUTF8(dir), 1);
     NE_DEBUG(DEBUG_FILES, "opendir: %s\n", dir);
     switch (fetch_resource_list(session.sess, real_path, 1, 0, &files)) {
     case NE_OK:
@@ -200,6 +202,7 @@
 	break;
     }	
     free(real_path);
+    free(pt);
     return (void *)ctx;
 }
 
@@ -213,8 +216,13 @@
 	NE_DEBUG(DEBUG_FILES, "none.\n");
 	return NULL;
     } else {
+	char *pt1, *pt2;
 	memset(&ent, 0, sizeof(struct dirent));
-	ne_strnzcpy(ent.d_name, ctx->current->uri + ctx->rootlen, 255);
+	pt1 = ne_path_unescape(ctx->current->uri + ctx->rootlen);
+	pt2 = fromUTF8(pt1);
+	ne_strnzcpy(ent.d_name, pt2, 255);
+	free(pt1);
+	free(pt2);
 	/* FIXME: non-portable, there's an autoconf 
 	 * test for this, "d-ino.m4" */
 	ent.d_ino = 1;
@@ -235,9 +243,10 @@
 static int davglob_stat(const char *filename, struct stat *st) {
     /* presumption: all glob needs to know is whether it's a directory
      * or not. I think this is true for the glob in glibc2 */
-    char *dir;
+    char *dir, *pt;
     NE_DEBUG(DEBUG_FILES, "stat %s\n", filename);
-    dir = resolve_path(session.uri.path, filename, 1);
+    dir = resolve_path(session.uri.path, pt = toUTF8(filename), 1);
+    free(pt);
     if (getrestype(dir) == resr_collection) {
 	st->st_mode = S_IFDIR;
     } else {
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/codeconv.c cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/codeconv.c
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/codeconv.c	1970-01-01 09:00:00.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/codeconv.c	2006-08-01 00:55:13.412233000 +0900
@@ -0,0 +1,114 @@
+/* 
+   cadaver, command-line DAV client
+   Copyright (C) 1999-2001, Joe Orton <joe@orton.demon.co.uk>
+                                                                     
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+*/
+
+#include "config.h"
+
+#include <string.h>
+#include <stdlib.h>
+
+#include "codeconv.h"
+
+#ifdef HAVE_ICONV
+#include <iconv.h>
+iconv_t toUTF8_cd = (iconv_t)-1, fromUTF8_cd = (iconv_t)-1;
+#endif
+
+void
+seticonv(const char *iocharset)
+{
+#ifdef HAVE_ICONV
+
+    const char *localcharset;
+
+    if (toUTF8_cd != (iconv_t)-1)
+	iconv_close(toUTF8_cd);
+
+    if (fromUTF8_cd != (iconv_t)-1)
+	iconv_close(fromUTF8_cd);
+
+    toUTF8_cd = (iconv_t)-1;
+    fromUTF8_cd = (iconv_t)-1;
+
+    localcharset = iocharset;
+
+    if (localcharset == NULL) return;
+    if (*localcharset == '\0') return;
+
+    toUTF8_cd = iconv_open("UTF-8", localcharset);
+    fromUTF8_cd = iconv_open(localcharset, "UTF-8");
+
+#endif
+    return ;
+}
+    
+
+char *
+toUTF8(const char *source)
+{
+#ifdef HAVE_ICONV
+
+    char *stmp = (char *)source, *res, *rtmp;
+    int slen, rlen;
+
+    if (source == NULL) return NULL;
+
+    if (toUTF8_cd == (iconv_t)-1)
+	return strdup(source);
+
+    slen = strlen(source) + 1;
+    rlen = slen * 4 + 1;
+    res = rtmp = (char *)malloc(rlen);
+
+    if (iconv(toUTF8_cd, &stmp, &slen, &rtmp, &rlen) != (size_t)-1)
+	if (slen == 0)
+	    return (char *)realloc(res, strlen(res) + 1);
+
+    free(res);
+
+#endif
+    return strdup(source);
+}
+
+char *
+fromUTF8(const char *source)
+{
+#ifdef HAVE_ICONV
+
+    char *stmp = (char *)source, *res, *rtmp;
+    int slen, rlen;
+
+    if (source == NULL) return NULL;
+
+    if (fromUTF8_cd == (iconv_t)-1)
+	return strdup(source);
+
+    slen = strlen(source) + 1;
+    rlen = slen + 1;
+    res = rtmp = (char *)malloc(rlen);
+
+    if (iconv(fromUTF8_cd, &stmp, &slen, &rtmp, &rlen) != (size_t)-1)
+	if (slen == 0)
+	    return (char *)realloc(res, strlen(res) + 1);
+
+    free(res);
+
+#endif
+    return strdup(source);
+}
+
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/codeconv.h cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/codeconv.h
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/codeconv.h	1970-01-01 09:00:00.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/codeconv.h	2006-08-01 00:55:13.432262000 +0900
@@ -0,0 +1,29 @@
+/* 
+   cadaver, command-line DAV client
+   Copyright (C) 1999-2001, Joe Orton <joe@orton.demon.co.uk>
+                                                                     
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+*/
+
+#ifndef CODECONV_H
+#define CODECONV_H
+
+extern char *toUTF8(const char *source);
+
+extern char *fromUTF8(const char *source);
+
+extern void seticonv(const char *iocharset);
+
+#endif
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/commands.c cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/commands.c
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/commands.c	2005-12-31 22:12:11.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/commands.c	2006-08-01 01:18:52.746468800 +0900
@@ -76,6 +76,7 @@
 #include "commands.h"
 #include "options.h"
 #include "utils.h"
+#include "codeconv.h"
 
 /* Local variables */
 int child_running; /* true when we have a child running */
@@ -114,7 +115,10 @@
  * (really 'METHOD' to 'RESOURCE' but hey.) */
 void out_start(const char *verb, const char *noun)
 {
-    output(o_start, "%s `%s':", verb, noun);
+    char *pt1, *pt2;
+    output(o_start, "%s `%s':", verb, (pt1 = fromUTF8(pt2 = ne_path_unescape(noun))));
+    free(pt1);
+    free(pt2);
 }
 
 void out_success(void)
@@ -224,88 +228,6 @@
     }
 }
 
-/* FIXME: joe: these are really wrong and result from my lack of
- * understanding of character set issues.  I think this needs iconv(),
- * but iconv isn't really portable, so what's the fallback for
- * platforms without iconv? Reject any non-ASCII input?  And even if
- * iconv is present, how is the input charset encoding determined? */
-static char *cad_utf8_encode(const char *str)
-{
-    char *buffer = ne_malloc(strlen(str) * 2 + 1);
-    int in, len = strlen(str);
-    char *out;
-
-    for (in = 0, out = buffer; in < len; in++, out++) {
-	if ((unsigned char)str[in] <= 0x7D) {
-	    *out = str[in];
-	} else {
-	    *out++ = 0xC0 | ((str[in] & 0xFC) >> 6);
-	    *out = str[in] & 0xBF;
-	}
-    }
-
-    /* nul-terminate */
-    *out = '\0';
-    return buffer;
-}
-
-/* Single byte range 0x00 -> 0x7F */
-#define SINGLEBYTE_UTF8(ch) (((unsigned char) (ch)) < 0x80)
-
-static char *cad_utf8_decode(const char *str)
-{
-    int n, m, len = strlen(str);
-    char *dest = ne_malloc(len + 1);
-    
-    for (n = 0, m = 0; n < len; n++, m++) {
-	if (SINGLEBYTE_UTF8(str[n])) {
-	    dest[m] = str[n];
-	} else {
-	    /* This just deals with 8-bit data, which will be encoded
-	     * as two bytes of UTF-8 */
-	    if ((len - n < 2) || (str[n] & 0xFC) != 0xC0) {
-		free(dest);
-		return NULL;
-	    } else {
-		dest[m] = ((str[n] & 0x03) << 6) | (str[n+1] & 0x3F);
-		n++;
-	    }
-	}
-    }
-    
-    dest[m] = '\0';
-    return dest;
-}
-
-/* If in UTF-8 mode, simply duplicates 'str'.  When not in UTF-8 mode,
- * presume 'str' is ISO-8859-1, and UTF-8 encode it. */
-static char *utf8_encode(const char *str)
-{
-    if (get_bool_option(opt_utf8)) {
-	return ne_strdup(str);
-    } else {
-	return cad_utf8_encode(str);
-    }
-}
-
-/* If in UTF-8 mode, simply duplicates 'str'.
- * When not in UTF-8 mode, does a UTF-8 decode on 'str',
- * or at least, the least significant 8-bits of the Unicode
- * characters in 'str'.  Returns NULL if 'str' contains
- * >8-bit characters.
- *
- * TODO: yes, is this sensible? embedded NUL's?
- */
-static char *utf8_decode(const char *str)
-{
-    /* decoded version can be at most as long as encoded version. */
-    if (get_bool_option(opt_utf8)) {
-	return ne_strdup(str);
-    } else {
-	return cad_utf8_decode(str);
-    }
-}
-
 /* Resolve path, appending trailing slash if resource is a
  * collection. */
 static char *true_path(const char *res)
@@ -425,9 +347,10 @@
 static void do_discover(const char *res, const char *mesg,
 			ne_lock_result result_cb)
 {
-    char *real_remote;
+    char *real_remote, *pt;
     int ret, count = 0;
-    real_remote = resolve_path(session.uri.path, res, false);
+    real_remote = resolve_path(session.uri.path, pt = toUTF8(res), false);
+    free(pt);
     out_start(mesg, res);
     ret = ne_lock_discover(session.sess, real_remote, result_cb, &count);
     switch (ret) {
@@ -470,11 +393,12 @@
 
 static void execute_lock(const char *res)
 {
-    char *real_remote;
+    char *real_remote, *pt;
     struct ne_lock *lock;
     enum resource_type rtype;
 
-    real_remote = resolve_path(session.uri.path, res, false);
+    real_remote = resolve_path(session.uri.path, pt = toUTF8(res), false);
+    free(pt);
     rtype = getrestype(real_remote);
     if (rtype == resr_collection) {
 	if (!ne_path_has_trailing_slash(real_remote)) {
@@ -512,9 +436,11 @@
 {
     struct ne_lock *lock;
     ne_uri uri;
+    char *pt;
 
     uri = session.uri; /* shallow copy */
-    uri.path = true_path(res);
+    uri.path = true_path(pt = toUTF8(res));
+    free(pt);
 
     out_start(_("Unlocking"), res);
     lock = ne_lockstore_findbyuri(session.locks, &uri);
@@ -540,7 +466,9 @@
 
 static void execute_mkcol(const char *name)
 {
-    char *uri = resolve_path(session.uri.path, name, true);
+    char *pt;
+    char *uri = resolve_path(session.uri.path, pt = toUTF8(name), true);
+    free(pt);
     dispatch(_("Creating"), name, ne_mkcol, uri);
     free(uri);
 }
@@ -548,9 +476,9 @@
 static int all_iterator(void *userdata, const ne_propname *pname,
 			 const char *value, const ne_status *status)
 {
-    char *dname = utf8_decode(pname->name);
+    char *dname = fromUTF8(pname->name);
     if (value != NULL) {
-	char *dval = utf8_decode(value);
+	char *dval = fromUTF8(value);
 	printf("%s = %s\n", dname, dval);
 	free(dval);
     } else if (status != NULL) {
@@ -575,11 +503,11 @@
 	return;
     }
     
-    dname = utf8_decode(pname->name);
+    dname = fromUTF8(pname->name);
 
     value = ne_propset_value(set, pname);
     if (value != NULL) {
-	char *dval = utf8_decode(value);
+	char *dval = fromUTF8(value);
 	printf(_("Value of %s is: %s\n"), dname, dval);
 	free(dval);
     } else {
@@ -604,27 +532,27 @@
 {
     ne_proppatch_operation ops[2];
     ne_propname pname;
-    char *uri = resolve_path(session.uri.path, res, false);
-    char *val = NULL /* quieten gcc */, *encname = utf8_encode(name);
+    char *pt1, *pt2;
+    char *uri = resolve_path(session.uri.path, pt1 = toUTF8(res), false);
+    free(pt1);
 
     ops[0].name = &pname;
     if (value) {
 	ops[0].type = ne_propset;
-	ops[0].value = val = utf8_encode(value);
+	ops[0].value = pt1 = toUTF8(value);
     } else {
 	ops[0].type = ne_propremove;
     }
     ops[1].name = NULL;
     
     pname.nspace = (const char *)get_option(opt_namespace);
-    pname.name = encname;
+    pname.name = pt2 = toUTF8(name);
     out_start(descr, res);
     out_handle(ne_proppatch(session.sess, uri, ops));
 
-    if (value) 
-	free(val);
-    free(encname);
     free(uri);
+    free(pt1);
+    free(pt2);
 }    
 
 
@@ -641,15 +569,18 @@
 static void execute_propget(const char *res, const char *name)
 {
     ne_propname pnames[2] = {{NULL}, {NULL}};
-    char *remote = resolve_path(session.uri.path, res, false), *encname = NULL;
+    char *remote, *encname = NULL, *pt;
     ne_propname *props;
     int ret;
     
+    remote = resolve_path(session.uri.path, pt = toUTF8(res), false);
+    free(pt);
+
     if (name == NULL) {
 	props = NULL;
     } else {
 	pnames[0].nspace = (const char *)get_option(opt_namespace);
-	pnames[0].name = encname = utf8_encode(name);
+	pnames[0].name = encname = toUTF8(name);
 	props = pnames;
     }
 
@@ -661,9 +592,7 @@
 	out_result(ret);
     }
 
-    if (encname) {
-	free(encname);
-    }
+    free(encname);
     free(remote);
 }
 
@@ -682,8 +611,9 @@
 
 static void execute_propnames(const char *res)
 {
-    char *remote;
-    remote = resolve_path(session.uri.path, res, false);
+    char *remote, *pt;
+    remote = resolve_path(session.uri.path, pt = toUTF8(res), false);
+    free(pt);
     out_start(_("Fetching property names"), res);
     if (out_handle(ne_propnames(session.sess, remote, NE_DEPTH_ZERO,
 				 propname_results, NULL))) { 
@@ -712,7 +642,9 @@
 
 static void execute_delete(const char *filename)
 {
-    char *remote = resolve_path(session.uri.path, filename, false);
+    char *remote, *pt;
+    remote = resolve_path(session.uri.path, pt = toUTF8(filename), false);
+    free(pt);
     out_start(_("Deleting"), filename);
     if (getrestype(remote) == resr_collection) {
 	output(o_finish, 
@@ -730,8 +662,9 @@
 
 static void execute_rmcol(const char *filename)
 {
-    char *remote;
-    remote = resolve_path(session.uri.path, filename, true);
+    char *remote, *pt;
+    remote = resolve_path(session.uri.path, pt = toUTF8(filename), true);
+    free(pt);
     out_start(_("Deleting collection"), filename);
     if (getrestype(remote) != resr_collection) {
 	output(o_finish, 
@@ -755,28 +688,28 @@
 static char *clever_path(const char *p, const char *src, 
 			 const char *dest)
 {
-    char *ret;
+    char *ret, *utf8src;
     int src_is_coll, dest_is_coll;
     dest_is_coll = (dest[strlen(dest)-1] == '/');
     src_is_coll = (src[strlen(src)-1] == '/');
+    utf8src = toUTF8(base_name(src));
     if (strcmp(dest, ".") == 0) {
-	ret = resolve_path(p, base_name(src), false);
+	ret = resolve_path(p, utf8src, false);
     } else if (strcmp(dest, "..") == 0) {
 	char *parent;
 	parent = ne_path_parent(p);
-	ret = resolve_path(parent, base_name(src), false);
+	ret = resolve_path(parent, utf8src, false);
 	free(parent);
     } else if (!src_is_coll && dest_is_coll) {
 	/* Moving a file to a collection... the destination should
 	 * be the basename of file concated with the collection. */
 	char *tmp = resolve_path(p, dest, true);
-        char *enc = escape_path(base_name(src));
-	ret = ne_concat(tmp, enc, NULL);
-        free(enc);
+	ret = ne_concat(tmp, utf8src, NULL);
 	free(tmp);
     } else {
 	ret = resolve_path(p, dest, false);
     }
+    free(utf8src);
     return ret;
 }
 
@@ -814,10 +747,11 @@
 
 static void execute_less(const char *resource)
 {
-    char *real_res;
+    char *real_res, *pt;
     const char *pager;
     FILE *p;
-    real_res = resolve_path(session.uri.path, resource, false);
+    real_res = resolve_path(session.uri.path, pt = toUTF8(resource), false);
+    free(pt);
     pager = choose_pager();
     printf(_("Displaying `%s':\n"), real_res);
     p = spawn_pager(pager);
@@ -835,7 +769,9 @@
 
 static void execute_cat(const char *resource)
 {
-    char *real_res = resolve_path(session.uri.path, resource, false);
+    char *real_res, *pt;
+    real_res = resolve_path(session.uri.path, pt = toUTF8(resource), false);
+    free(pt);
     printf(_("Displaying `%s':\n"), real_res);
     if (ne_get(session.sess, real_res, STDOUT_FILENO) != NE_OK) {
 	printf(_("Failed: %s\n"), ne_get_error(session.sess));
@@ -847,14 +783,16 @@
 			void (*cb)(const char *, const char *))
 {
     /* We are guaranteed that argc > 2... */
-    char *dest;
+    char *dest, *pt;
 
-    dest = resolve_path(session.uri.path, argv[argc-1], true);
+    dest = resolve_path(session.uri.path, pt = toUTF8(argv[argc-1]), true);
+    free(pt);
     if (getrestype(dest) == resr_collection) {
 	int n;
 	char *real_src, *real_dest;
 	for(n = 0; n < argc-1; n++) {
-	    real_src = resolve_path(session.uri.path, argv[n], false);
+	    real_src = resolve_path(session.uri.path, pt = toUTF8(argv[n]), false);
+	    free(pt);
 	    real_dest = clever_path(session.uri.path, argv[n], dest);
 	    if (strcmp(real_src, real_dest) == 0) {
 		printf(_("%s: %s and %s are the same resource.\n"), v2,
@@ -870,8 +808,10 @@
                  "argument must be a collection.\n"), v1);
     } else {
 	char *rsrc, *rdest;
-	rsrc = resolve_path(session.uri.path, argv[0], false);
-	rdest = resolve_path(session.uri.path, argv[1], false);
+	rsrc = resolve_path(session.uri.path, pt = toUTF8(argv[0]), false);
+	free(pt);
+	rdest = resolve_path(session.uri.path, pt = toUTF8(argv[1]), false);
+	free(pt);
 	/* Simple */
 	(*cb) (rsrc, rdest);
 	free(rsrc);
@@ -940,8 +880,9 @@
 
 static void execute_get(const char *remote, const char *local)
 {
-    char *filename, *real_remote;
-    real_remote = resolve_path(session.uri.path, remote, false);
+    char *filename, *real_remote, *pt;
+    real_remote = resolve_path(session.uri.path, pt = toUTF8(remote), false);
+    free(pt);
     if (local == NULL) {
 	struct stat st;
 	/* Choose an appropriate local filename */
@@ -949,7 +890,8 @@
 	    char buf[BUFSIZ];
 	    /* File already exists... don't overwrite */
 	    snprintf(buf, BUFSIZ, _("Enter local filename for `%s': "),
-		     real_remote);
+		     pt = fromUTF8(real_remote));
+	    free(pt);
 	    filename = readline(buf);
 	    if (filename == NULL) {
 		free(real_remote);
@@ -964,7 +906,8 @@
     }
     {
 	int fd = open(filename, O_CREAT|O_WRONLY|O_TRUNC, 0644);
-	output(o_transfer, _("Downloading `%s' to %s:"), real_remote, filename);
+	output(o_transfer, _("Downloading `%s' to %s:"), pt = fromUTF8(real_remote), filename);
+	free(pt);
 	if (fd < 0) {
 	    output(o_finish, _("failed:\n%s\n"), strerror(errno));
 	} else {
@@ -984,8 +927,10 @@
 
 static void simple_put(const char *local, const char *remote)
 {
+    char *pt;
     int fd = open(local, O_RDONLY | OPEN_BINARY_FLAGS);
-    output(o_transfer, _("Uploading %s to `%s':"), local, remote);
+    output(o_transfer, _("Uploading %s to `%s':"), local, pt = fromUTF8(remote));
+    free(pt);
     if (fd < 0) {
 	output(o_finish, _("Could not open file: %s\n"), strerror(errno));
     } else {
@@ -996,11 +941,13 @@
 
 static void execute_put(const char *local, const char *remote)
 {
-    char *real_remote;
+    char *real_remote, *pt;
     if (remote == NULL) {
-	real_remote = resolve_path(session.uri.path, base_name(local), false);
+	real_remote = resolve_path(session.uri.path, pt = toUTF8(base_name(local)), false);
+	free(pt);
     } else {
-	real_remote = resolve_path(session.uri.path, remote, false);
+	real_remote = resolve_path(session.uri.path, pt = toUTF8(remote), false);
+	free(pt);
     }
     simple_put(local, real_remote);
     free(real_remote);
@@ -1056,9 +1003,11 @@
 static void multi_mput(int argc, const char *argv[])
 {
     for(; argv[0] != NULL; argv++) {
-	char *remote = resolve_path(session.uri.path, argv[0], false);
+	char *pt;
+	char *remote = resolve_path(session.uri.path, pt = toUTF8(argv[0]), false);
 	simple_put(argv[0], remote);
 	free(remote);
+	free(pt);
     }    
 }
 
@@ -1075,7 +1024,7 @@
     { "http://apache.org/dav/props/", "executable" };
     /* Use a single operation; set the executable property to... */
     ne_proppatch_operation ops[] = { { &execprop, ne_propset, NULL }, { NULL } };
-    char *uri;
+    char *uri, *pt;
     ne_server_capabilities caps = {0};
     int ret;
 
@@ -1092,7 +1041,8 @@
 	return;
     }
     
-    uri = resolve_path(session.uri.path, remote, false);
+    uri = resolve_path(session.uri.path, pt = toUTF8(remote), false);
+    free(pt);
 
     out_start(_("Setting isexecutable"), remote);
     ret = ne_options(session.sess, uri, &caps);
@@ -1164,14 +1114,16 @@
 
 static void execute_pwd(void)
 {
+    char *pt;
     char *uri = ne_uri_unparse(&session.uri);
-    printf(_("Current collection is `%s'.\n"), uri);
+    printf(_("Current collection is `%s'.\n"), (pt = fromUTF8(uri)));
     ne_free(uri);
+    ne_free(pt);
 }
 
 static void execute_cd(const char *newpath)
 {
-    char *real_path;
+    char *real_path, *pt;
     int is_swap = false;
     if (strcmp(newpath, "-") == 0) {
 	if (!session.lastwp) {
@@ -1181,7 +1133,8 @@
 	is_swap = true;
 	real_path = session.lastwp;
     } else {
-	real_path = resolve_path(session.uri.path, newpath, true);
+	real_path = resolve_path(session.uri.path, pt = toUTF8(newpath), true);
+	free(pt);
     }
     if (set_path(real_path)) {
 	/* Error */
@@ -1207,7 +1160,7 @@
         if (pos == 6) printf("\n ");
 #if 0        
 	if (commands[n].call && commands[n].short_help) {
-	    printf(" %-26s %s\n", commands[n].call, _(commands[n].short_help));
+	    printf(" %-26s %s\n", commands[n].call, commands[n].short_help);
 	}
 #endif
     }
@@ -1229,7 +1182,7 @@
 	const struct command *cmd = get_command(arg);
 
 	if (cmd) {
-	    printf(_(" `%s'   %s\n"), cmd->call, _(cmd->short_help));
+	    printf(_(" `%s'   %s\n"), cmd->call, cmd->short_help);
 	    if (cmd->needs_connection) {
 		printf(_("This command can only be used when connected to a server.\n"));
 	    }
@@ -1295,9 +1248,9 @@
     C1(cd, N_("cd path"), N_("Change to specified collection")),
     { cmd_pwd, "pwd", true, 0, 0, parmscope_none, T0(execute_pwd),
       "pwd", N_("Display name of current collection") },
-    { cmd_put, "put", true, 1, 2, parmscope_none, T2(execute_put),
+    { cmd_put, "put", true, 1, 2, parmscope_local, T2(execute_put),
       N_("put local [remote]"), N_("Upload local file") },
-    { cmd_get, "get", true, 1, 2, parmscope_none, T2(execute_get),
+    { cmd_get, "get", true, 1, 2, parmscope_remote, T2(execute_get),
       N_("get remote [local]"), N_("Download remote resource") },
     C1M(mget, N_("mget remote..."), N_("Download many remote resources")),
     { cmd_mput, "mput", true, 1, CMD_VARY, parmscope_local, TV(multi_mput), 
@@ -1319,7 +1272,7 @@
     C1(unlock, N_("unlock resource"), N_("Unlock given resource")),
     C1(discover, N_("discover resource"), N_("Display lock information for resource")),
     C1(steal, N_("steal resource"), N_("Steal lock token for resource")),
-    { cmd_showlocks, "showlocks", true, 0, 0, parmscope_none, T0(execute_showlocks),
+    { cmd_showlocks, "showlocks", true, 0, 0, parmscope_remote, T0(execute_showlocks),
       "showlocks", N_("Display list of owned locks") },
 
     /*** DeltaV commands ***/
@@ -1335,12 +1288,12 @@
 
 
     /*** Property handling ***/
-    C1(propnames, "propnames res", N_("Names of properties defined on resource")) ,
+    C1(propnames, N_("propnames res"), N_("Names of properties defined on resource")) ,
 
-    { cmd_chexec, "chexec", true, 2, 2, parmscope_none, T2(execute_chexec),
+    { cmd_chexec, "chexec", true, 2, 2, parmscope_remote, T2(execute_chexec),
       N_("chexec [+|-] remote"), N_("Change isexecutable property of resource") },
     
-    { cmd_propget, "propget", true, 1, 2, parmscope_none, T2(execute_propget),
+    { cmd_propget, "propget", true, 1, 2, parmscope_remote, T2(execute_propget),
       N_("propget res [propname]"), 
       N_("Retrieve properties of resource") },
     { cmd_propdel, "propdel", true, 2, 2, parmscope_none, T2(execute_propdel),
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/edit.c cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/edit.c
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/edit.c	2005-12-31 21:57:37.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/edit.c	2006-08-01 00:44:37.507848000 +0900
@@ -50,6 +50,7 @@
 #include "utils.h"
 #include "options.h"
 #include "i18n.h"
+#include "codeconv.h"
 
 static int run_editor(const char *filename)
 {
@@ -111,7 +112,7 @@
    set O_BINARY, if that is allowed under cygwin? */
 void execute_edit(const char *remote)
 {
-    char *real_remote;
+    char *real_remote, *pt;
     unsigned int can_lock; /* can we LOCK it? */
     struct ne_lock *lock = NULL;
     char fname[_POSIX_PATH_MAX] = "/tmp/cadaver-edit-XXXXXX";
@@ -119,7 +120,8 @@
     int fd;
     int is_checkout, is_checkin;
     
-    real_remote = resolve_path(session.uri.path, remote, false);
+    real_remote = resolve_path(session.uri.path, pt = toUTF8(remote), false);
+    free(pt);
 
     /* Don't let them edit a collection, since PUT to a collection is
      * bogus. Really we want to be able to fetch a "DefaultDocument"
